using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace DrumPad
{
    /// <summary>
    /// To jest główny typ dla naszej gry
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // Świat Gry
        SoundEffect kick;
        SoundEffect cymbolTing;
        SoundEffect snare;
        SoundEffect top;

        // Bieżący stan gamepada podczas metody Update()
        GamePadState pad1;

        // Poprzedni stan gamepada. XNA inicjalizuje do stanu żaden  
        // przycisk nie wciśnięty. Po pierwszym wywołaniu metody Update()
        // będzie tu przechowywany poprzedni stan gamepada
        GamePadState oldpad1;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Pozwala grze wykonać dowolną inicjalizację jakiej potrzebuje przed rozpoczeciem działania.
        /// To tutaj może ona zażądać potrzebnych usług i załadować związaną zawartość nie graficzną.
        /// Wywołanie base.Initialize wyliczy wszystkie komponenty i także je zainicjuje.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Dodaj w tym miejscu swoją logikę inicjalizacji

            base.Initialize();
        }

        /// <summary>
        /// LoadContent bedzie wywołany raz na grę i tu należy ładować
        /// całą zawartość.
        /// </summary>
        protected override void LoadContent()
        {
            // Stwórz nowy SpriteBatch, którego można uzyć do rysowania tekstur.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            kick = Content.Load<SoundEffect>("kick");
            cymbolTing = Content.Load<SoundEffect>("cymbolTing");
            snare = Content.Load<SoundEffect>("snare");
            top = Content.Load<SoundEffect>("top");
        }

        /// <summary>
        /// UnloadContent bedzie wywołany raz na grę i tu należy usuwać 
        /// całą zawartość.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Usunąć w tym miejscu każdą zawartość nie obsługiwaną przez ContentManager
        }

        /// <summary>
        /// Pozwala uruchomić w grze logikę, taką jak aktualizacja świata,
        /// sprawdzenie kolizji, pobranie wejścia i odtwarzanie dźwięku.
        /// </summary>
        /// <param name="gameTime">Dostarcza chwilową wartość zmiennych czasowych.</param>
        protected override void Update(GameTime gameTime)
        {
            // Pozwala na wyjście z gry
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            pad1 = GamePad.GetState(PlayerIndex.One);

            if (pad1.IsConnected)
            {
                // pozwala na wyjście, gdy zostanie wciśniety przycisk back
                if (pad1.Buttons.Back == ButtonState.Pressed)
                {
                    this.Exit();
                }

                // sprawdź, czy przycisk A został wciśnięty od ostatniego wywołania metody Update()
                if (oldpad1.Buttons.A == ButtonState.Released &&
                     pad1.Buttons.A == ButtonState.Pressed)
                {
                    cymbolTing.Play();
                }

                // sprawdź, czy przycisk B został wciśnięty od ostatniego wywołania metody Update()
                if (oldpad1.Buttons.B == ButtonState.Released &&
                     pad1.Buttons.B == ButtonState.Pressed)
                {
                    kick.Play();
                }

                // sprawdź, czy przycisk X został wciśnięty od ostatniego wywołania metody Update()
                if (oldpad1.Buttons.X == ButtonState.Released &&
                     pad1.Buttons.X == ButtonState.Pressed)
                {
                    snare.Play();
                }

                // sprawdź, czy przycisk Y został wciśnięty od ostatniego wywołania metody Update()
                if (oldpad1.Buttons.Y == ButtonState.Released &&
                     pad1.Buttons.Y == ButtonState.Pressed)
                {
                    top.Play();
                }
            }

            // zapisz bieżący stan gamepada dla nastepnego
            // wywołania metody Update()
            oldpad1 = pad1;


            base.Update(gameTime);
        }

        /// <summary>
        /// Metoda wywoływana kiedy gra powinna się wyswietlić.
        /// </summary>
        /// <param name="gameTime">Dostarcza chwilową wartość zmiennych czasowych.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Dodaj w tym miejscu kod wyswietlający

            base.Draw(gameTime);
        }
    }
}
